// This file added in headers queue
// File: "Sources.h"

namespace GOTHIC_ENGINE {

    //main timer variables
    zCView* TimerView = Null;
    uint64 SessionTimerBegin = 0; // Main session timer
    uint64 SessionEndTime = Invalid;
    bool CanUpdateTimerView = true;


    //stop game closing after finish in G1
    HOOK Hook_CGameManager_ExitGame AS(&CGameManager::ExitGame, &CGameManager::ExitGame_Union);
    int CGameManager::ExitGame_Union() {
        return 0;
    }

    //Mudball
    /*
    HOOK Hook_zCViewPrint_PrintLines AS(&zCViewPrint::PrintLines, &zCViewPrint::PrintLines_Union);
    void __fastcall zCViewPrint::PrintLines_Union(class zSTRING& a1) {
        // End session!
        if (a1.HasWordI("Treffer"))
            SessionEndTime = GetTickCount64() - SessionTimerBegin;

        THISCALL(Hook_zCViewPrint_PrintLines)(a1);
    }

    HOOK Hook_zCView_CreateText AS(&zCView::CreateText, &zCView::CreateText_Union);
    zCViewText* __thiscall zCView::CreateText_Union(int a1, int a2, zSTRING const& a3, float a4, struct zCOLOR& a5, int a6, int a7) {
        // End session!
        if (a3.HasWordI("Treffer"))
            SessionEndTime = GetTickCount64() - SessionTimerBegin;

        return THISCALL(Hook_zCView_CreateText)(a1, a2, a3, a4, a5, a6, a7);
    }
    */ 


    HOOK Hook_CGameManager_PlayVideo AS(&CGameManager::PlayVideo, &CGameManager::PlayVideo_Union);
#if ENGINE >= Engine_G2
    int CGameManager::PlayVideo_Union(zSTRING name) {
#else
    int CGameManager::PlayVideo_Union(zSTRING name, int a2) {
#endif
        // End session!
        if (name.HasWordI("Extro.bik") || name.HasWordI("Extro_Xardas"))
            SessionEndTime = GetTickCount64() - SessionTimerBegin;

        // Don't update timer in video
        CanUpdateTimerView = false;
#if ENGINE >= Engine_G2
        int Ok = THISCALL(Hook_CGameManager_PlayVideo)(name);
#else
        int Ok = THISCALL(Hook_CGameManager_PlayVideo)(name, a2);
#endif
        CanUpdateTimerView = true;
        return Ok;
    }

    string GetTimeNumberFormated(uint64 timePtr, uint length) {
        string number = timePtr;
        while (number.Length() < length)
            number = "0" + number;

        return number;
    }

    string GetTimeStringFormated_Help(uint64 timePtr) {
#pragma warning(disable:4244)
        long hr = timePtr / 3600000;
        timePtr = timePtr - 3600000 * hr;

        long min = timePtr / 60000;
        timePtr = timePtr - 60000 * min;

        long sec = timePtr / 1000;
        timePtr = timePtr - 1000 * sec;
#pragma warning(default:4244)

        string hour = string::Combine("%i:", hr);
        string rest = string::Combine("%s:%s.%s", GetTimeNumberFormated(min, 2), GetTimeNumberFormated(sec, 2), GetTimeNumberFormated(timePtr, 3));
        if (hr > 0)
            return hour + rest;
        else
            return rest;
    }

    string GetTimeStringFormated(uint64 timePtr) {
        return "Run time: " + GetTimeStringFormated_Help(timePtr);
    }


    void Game_Entry() {
    }

    void Game_Init() {
        TimerView = new zCView();
        screen->InsertItem(TimerView, True);
        TimerView->SetPos(0, 0);
        TimerView->SetSize(3000, 1000);
        TimerView->SetFont("FONT_OLD_20_WHITE.TGA");
        TimerView->Print(100, 100, GetTimeStringFormated(0));

        SessionTimerBegin = GetTickCount64();
        SessionEndTime = Invalid;
    }

    void Game_Exit() {
    }

    bool inLoad, newLoad = false;
    uint64 loadStart, loadEnd = 0;
    uint64 realTime, gameTime, loadTime = 0;
    bool start = false;

    int FreezeTimerFrames = -1;


    HOOK Hook_zCCamera_PostRenderProcessing AS(&zCCamera::PostRenderProcessing, &zCCamera::PostRenderProcessing_Union);
    void __thiscall zCCamera::PostRenderProcessing_Union(void) {

        if (FreezeTimerFrames != -1 && FreezeTimerFrames-- == 0)
        {
            // TO DO Resume timer
            FreezeTimerFrames = 1;




            if (inLoad == true) {
                inLoad = false;
                loadEnd = GetTickCount64();
                newLoad = true;
                //detect new game
                if (start == false) {
                    loadTime, realTime = 0;
                    SessionTimerBegin = GetTickCount64();
                    start = true;
                    loadStart, loadEnd = 0;
                }
            }
        }

        THISCALL(Hook_zCCamera_PostRenderProcessing)();
    }
    HOOK Hook_zCViewProgressBar_Draw AS(&zCViewProgressBar::Draw, &zCViewProgressBar::Draw_Union);
    void __thiscall zCViewProgressBar::Draw_Union() {

        if (inLoad == false) {
            loadStart = GetTickCount64();
            inLoad = true;
        }

        THISCALL(Hook_zCViewProgressBar_Draw)();
    }

 
    
    void Game_Loop() {

        

        //update total time
        realTime = GetTickCount64() - SessionTimerBegin;
        //add new load time
        if (newLoad == true) {
            inLoad = false;
            loadEnd = loadEnd - loadStart;
            if (loadEnd > 0) {
                loadTime += loadEnd;
            }
            loadStart, loadEnd = 0;
            newLoad = false;
        }
        if (loadTime > realTime) {
            loadTime = 0;
        }
        //subtract loads from total time
        gameTime = realTime - loadTime;


        if (CanUpdateTimerView && SessionEndTime == Invalid) {
            TimerView->ClrPrintwin();
            TimerView->Print(100, 100, GetTimeStringFormated(gameTime));// + " " + GetTimeStringFormated(gameTime) + " " + GetTimeStringFormated(loadTime));
        }

    }

    // Information about current saving or loading world
    TSaveLoadGameInfo& SaveLoadGameInfo = UnionCore::SaveLoadGameInfo;

    void Game_SaveBegin() {
    }

    void Game_SaveEnd() {
    }

    void LoadBegin() {
    }

    void LoadEnd() {
        FreezeTimerFrames = 1; // == 1 frame
    }

    void Game_LoadBegin_NewGame() {
        LoadBegin();
    }

    void Game_LoadEnd_NewGame() {
        LoadEnd();

        // Start timer
        SessionTimerBegin = GetTickCount64();
        SessionEndTime = Invalid;
        //inLoad = true;
        start = false;
    }

    void Game_LoadBegin_SaveGame() {
        LoadBegin();
    }

    void Game_LoadEnd_SaveGame() {
        LoadEnd();
    }

    void Game_LoadBegin_ChangeLevel() {
        LoadBegin();
    }

    void Game_LoadEnd_ChangeLevel() {
        LoadEnd();
    }

    void Game_LoadBegin_Trigger() {
    }

    void Game_LoadEnd_Trigger() {
    }

    void Game_Pause() {
    }

    void Game_Unpause() {
    }

    void Game_DefineExternals() {
    }

    /////////////////////
    //Sequel Categories//
    /////////////////////

#if ENGINE == Engine_G1A
    //Sequel WIP - not implented yet
    //  Kein magisches Talent
    //  Und, wie gehts jetzt weiter? (WORKINPROGRESS)


    HOOK Hook_zCViewDialogChoice_AddChoice AS(&zCViewDialogChoice::AddChoice, &zCViewDialogChoice::AddChoice_Union);
    void __fastcall zCViewDialogChoice::AddChoice_Union(zSTRING& a1, int a2) {
        if (a1.HasWordI("(WORKINPROGRESS)")) {
            SessionEndTime = GetTickCount64() - SessionTimerBegin;
        }
        THISCALL(Hook_zCViewDialogChoice_AddChoice)(a1, a2);
    }


    //Sequel Chapter 2
    /* unneccessary since the timer freezes on chapter screen anyway
    HOOK Hook_CGameManager_IntroduceChapter AS(&CGameManager::IntroduceChapter, &CGameManager::IntroduceChapter_Union);
    int CGameManager::IntroduceChapter_Union(zSTRING chapter, zSTRING a2, zSTRING a3, zSTRING a4, int a5) {
        int Ok = THISCALL(Hook_CGameManager_IntroduceChapter)(chapter, a2, a3, a4, a5);
        if (chapter.HasWordI("Kapitel 2")) {
            SessionEndTime = GetTickCount64() - SessionTimerBegin;
        }
        return Ok;
    }
    */

    //Sequel Phoenix Quest
    HOOK Hook_oCDocumentManager_PrintLines AS(&oCDocumentManager::PrintLines, &oCDocumentManager::PrintLines_Union);
    void __fastcall oCDocumentManager::PrintLines_Union(int a1, int a2, zSTRING& text) {
        if (text.HasWordI("Du hast das R")) {
            SessionEndTime = GetTickCount64() - SessionTimerBegin;
        }
        THISCALL(Hook_oCDocumentManager_PrintLines)(a1, a2, text);
    }
#endif

    /*
    Functions call order on Game initialization:
      - Game_Entry           * Gothic entry point
      - Game_DefineExternals * Define external script functions
      - Game_Init            * After DAT files init

    Functions call order on Change level:
      - Game_LoadBegin_Trigger     * Entry in trigger
      - Game_LoadEnd_Trigger       *
      - Game_Loop                  * Frame call window
      - Game_LoadBegin_ChangeLevel * Load begin
      - Game_SaveBegin             * Save previous level information
      - Game_SaveEnd               *
      - Game_LoadEnd_ChangeLevel   *

    Functions call order on Save game:
      - Game_Pause     * Open menu
      - Game_Unpause   * Click on save
      - Game_Loop      * Frame call window
      - Game_SaveBegin * Save begin
      - Game_SaveEnd   *

    Functions call order on Load game:
      - Game_Pause              * Open menu
      - Game_Unpause            * Click on load
      - Game_LoadBegin_SaveGame * Load begin
      - Game_LoadEnd_SaveGame   *
    */

#define AppDefault True
    CApplication* lpApplication = !CHECK_THIS_ENGINE ? Null : CApplication::CreateRefApplication(
        Enabled(AppDefault) Game_Entry,
        Enabled(AppDefault) Game_Init,
        Enabled(AppDefault) Game_Exit,
        Enabled(AppDefault) Game_Loop,
        Enabled(AppDefault) Game_SaveBegin,
        Enabled(AppDefault) Game_SaveEnd,
        Enabled(AppDefault) Game_LoadBegin_NewGame,
        Enabled(AppDefault) Game_LoadEnd_NewGame,
        Enabled(AppDefault) Game_LoadBegin_SaveGame,
        Enabled(AppDefault) Game_LoadEnd_SaveGame,
        Enabled(AppDefault) Game_LoadBegin_ChangeLevel,
        Enabled(AppDefault) Game_LoadEnd_ChangeLevel,
        Enabled(AppDefault) Game_LoadBegin_Trigger,
        Enabled(AppDefault) Game_LoadEnd_Trigger,
        Enabled(AppDefault) Game_Pause,
        Enabled(AppDefault) Game_Unpause,
        Enabled(AppDefault) Game_DefineExternals
    );
}